#ifndef EGL_BUS_HW_H
#define EGL_BUS_HW_H

#include "sip2_common.h"
#include "sys/egl_sys_arch.h"
/*
Note: Please make your platform port_busxx.c  to realize the func below
*/

extern u32 SPI_BLOCK_SIZE;          //  1 ~ 2048

//extern u16 SPI_BLOCK_SIZE;

/*
1 SPI/NVIC_GPIO,NVIC,DMA,SPI hardware ini.
2 SPI bus cmd ini.
3 BusHoldMutex ini.
4 BusIrqReadSem ini.
*/
void bus_ini(void);

void bus_irq_en(u8 enable);

void bus_claim_host(void);
void bus_release_host(void);

//int sdio_writesb(unsigned int addr, void *src,int count);
//int sdio_memcpy_toio(unsigned int addr,void *src, int count);
//int sdio_readsb(void *dst, unsigned int addr, int count);
//int sdio_memcpy_fromio(void *dst,unsigned int addr, int count);
//int sdio_enable_func(struct sdio_func *func);

u8 BusReadReg(u32 addr, int *err_ret );
//int BusWriteReg(u32 addr, u8 value,u8 func);
/*
int BusWriteBytes(u32 addr, void *src,u32 count);
int BusWriteBlocks(u32 addr,void *src, u32 count);

int BusReadBytes(u32 addr, void *dst, u32 count);
int BusReadBlocks(u32 addr, void *dst, u32 count);
*/
int sif_spi_write_bytes(u32 addr, u8* src,u16 count,u8 func);
int sif_spi_read_bytes(u32 addr,  u8* dst,u16 count,u8 func);
int sif_spi_write_blocks(u32 addr,u8* src,u16 count,u16 block_size);
int sif_spi_read_blocks(u32 addr, u8* dst,u16 count,u16 block_size);

extern egl_sem_t BusIrqReadSem;

#endif