#include <string.h>
#include "egl_netbuf.h"
#include "sys/egl_sys_arch.h"
#include "sip2_common.h"

#define AR6000_DATA_OFFSET   64 //why  offset??

void *
a_netbuf_alloc(int size)
{
       skb_t *skb;
#if 1
	skb = (skb_t*)egl_malloc(sizeof(skb_t));
       memset(skb, 0, sizeof(skb_t));
       skb->buf = (u8*)egl_malloc( size );
#else
	skb = (skb_t*)malloc(sizeof(skb_t));
       memset(skb, 0, sizeof(skb_t));
       skb->buf = (u8*)malloc( size );
#endif
       
	//skb->buf_len = AR6000_DATA_OFFSET + sizeof(HTC_PACKET) + size;
	skb->len = 0;
	skb->data = skb->buf;

	//printf("~~~~~alloc %08x  ~~~~", skb);
	return ((void *)skb);
}

void *
a_netbuf_alloc2(int size)
{
    skb_t *skb;
	skb = (skb_t*)pvPortMalloc(sizeof(skb_t));
	memset(skb, 0, sizeof(skb_t));
    skb->buf = (u8*)pvPortMalloc( size);
	//skb->buf_len = sizeof(HTC_PACKET) + size;
	skb->len = 0;
	skb->data = skb->buf ;

	//printf("~~~~~alloc2 %08x  ~~~~", skb);
	return ((void *)skb);
}


void
a_netbuf_free(void *bufPtr)
{
    skb_t *skb = (skb_t *)bufPtr;
#if 1
	egl_free(skb->buf);
	egl_free(skb);
#else
    	free(skb->buf);
	free(skb);
#endif

	//printf("~~~~~free %08x  ~~~~", skb);	
}


A_STATUS
a_netbuf_push(void *bufPtr, u32 len)
{
	skb_t *skb = (skb_t*)bufPtr;
    skb->data -= len;
	skb->len += len;

    return A_OK;
}

A_STATUS
a_netbuf_put(void *bufPtr, u32 len)
{
	skb_t *skb = (skb_t*)bufPtr;
	skb->len += len;

    return A_OK;
}

#if 0
/**
 * Trim the network buffer pointed to by bufPtr to len # of bytes
 */
A_STATUS
a_netbuf_setlen(void *bufPtr, u32 len)
{
        skb_trim((struct sk_buff *)bufPtr, len);
        return A_OK;
}

/**
* Chop of len # of bytes from the end of the buffer and return the data.
*/
A_STATUS
a_netbuf_trim_data(void *bufPtr, char *dstPtr, A_INT32 len)
{
        char *start = (char*)(((struct sk_buff *)bufPtr)->data +
        (((struct sk_buff *)bufPtr)->len - len));

        A_MEMCPY(dstPtr, start, len);
        skb_trim((struct sk_buff *)bufPtr, ((struct sk_buff *)bufPtr)->len - len);
        return A_OK;
}
#endif

A_STATUS
a_netbuf_setlen(void *bufPtr, u32 len)
{
        skb_t *skb = (skb_t*)bufPtr;
        skb->len = len;
        return A_OK;
}


A_STATUS
a_netbuf_trim(void *bufPtr, u32 len)
{
        skb_t *skb = (skb_t*)bufPtr;
        //skb_trim((struct sk_buff *)bufPtr, ((struct sk_buff *)bufPtr)->len - len);
        skb->len -= len;
        return A_OK;
}



A_STATUS
a_netbuf_pull(void *bufPtr, u32 len)
{
	skb_t *skb = (skb_t*)bufPtr;
    skb->data += len;
	skb->len -= len;

    return A_OK;
}

u32
a_netbuf_to_len(void *bufPtr)
{
    return (((skb_t *)bufPtr)->len);
}

u8 *
a_netbuf_to_data(void *bufPtr)
{
    return (((skb_t *)bufPtr)->data);
}

