/*
 * Copyright (c) 2009 - 2012 Espressif System.
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "sip2_common.h"
#include "esp_ctrl.h"
#include "esp_sip.h"
#include "linux_inc\net\cfg80211.h"
#include "esp_main_sim.h"
#include "esp_pub.h"

extern int RXQueueWorkFlag ;
extern egl_sem_t  QueueWorkCntSem;

extern char GlBootupCplx;
extern void *EpubAddr;

int sip_parse_events(struct esp_sip *sip, u8 *buf)
{
       struct sip_hdr *hdr = (struct sip_hdr *)buf;

       switch (hdr->c_evtid) 
       {
            	case SIP_EVT_TARGET_ON: 
              {
                    u8 s = 1;
                     sip_handle_target_on(sip, &s);
                     
            		/* use rx work queue to send... */
            		if ( sip->state == SIP_PREPARE_BOOT || sip->state == SIP_BOOT ) 
                     {
            			sip->state= SIP_SEND_INIT;
            			RXQueueWorkFlag++;
            			//egl_sem_signal(&QueueWorkCntSem);
            		} 
                     else 
            		{
            			printf("boot during wrong state:%d\n",sip->state);
            		}
                            break;
            	 }

                case SIP_EVT_BOOTUP: 
                {
                        struct sip_evt_bootup2 *bootup_evt = (struct sip_evt_bootup2 *)(buf + SIP_CTRL_HDR_LEN);
                        sip_handle_bootup(sip, bootup_evt);


printf("sip->rawbuf addr:%x\n",sip->rawbuf);
                        //if (sip->rawbuf)        /* used in boot stage, free once chip is fully up */
                        //egl_free(sip->rawbuf);
                        sip_post_init(sip, bootup_evt);

                        if (GlBootupCplx == 0)	
                            GlBootupCplx = 1;
                        break;
                }
                case SIP_EVT_CREDIT_RPT:
                        break;

                case SIP_EVT_SNPRINTF_TO_HOST: 
                {
                        u8 *p = (buf + sizeof(struct sip_hdr) + sizeof(u16));
                        u16 *len = (u16 *)(buf + sizeof(struct sip_hdr));
                        
                        printf("SIP_EVT_SNPRINTF_TO_HOST,len:%d \n", *len);
                        //esp_dbg(ESP_SHOW, "esp_target: %.*s \n", *len, p);
                        //printf("esp_target: %.*s \n", *len, p);
                        break;
                }
                case SIP_EVT_SCAN_COMPLETE: 
                {
                        u8 *scan_status = (u8 *)(buf + SIP_CTRL_HDR_LEN);
                        sip_handle_scan_complete(sip, scan_status);
                        break;
                }    
                case SIP_EVT_BSSINFO: 
                {
                        struct sip_evt_bssinfo *bssinfo = (struct sip_evt_bssinfo *)(buf + SIP_CTRL_HDR_LEN);
                        sip_handle_bssinfo(sip, bssinfo);
                        break;
                } 
                case SIP_EVT_CONNECT: 
                {
                        struct sip_evt_connect *connect = (struct sip_evt_connect *)(buf + SIP_CTRL_HDR_LEN);
                        sip_handle_connect(sip, connect);
                        break;
                } 
                case SIP_EVT_DISCONNECT: 
                {
                        struct sip_evt_disconnect *disconnect = (struct sip_evt_disconnect *)(buf + SIP_CTRL_HDR_LEN);
                        sip_handle_disconnect(sip, disconnect);
                        break;
                } 
        }

        return 0;
}
/*************Event Ĵ**********************/

#include "esp_init_data.h"

void sip_send_chip_init(struct esp_sip *sip)
{
	u32 size = 0;
	size = sizeof(esp_init_data);
	sip->tx_credits -= 1;
	sip_send_cmd(sip, SIP_CMD_INIT, size, (void *)esp_init_data);
}

//below is justt tests
void sip_handle_target_on(struct esp_sip *sip, u8 *on)
{
        struct esp_pub *epub = (struct esp_pub *)EpubAddr; 
printf("target_on: %d \n", *on);

//Innerr handle....  

        
        // Throw out  msg;
        if( epub->user_evt_mbox )
        {
                struct user_msg  *msg = (struct user_msg *)egl_malloc(sizeof(struct user_msg));
                msg->id = 10;
                msg->len = sizeof(u8);
                msg->data = (u8 *)egl_malloc(msg->len);
                memcpy(msg->data,on,msg->len);
                 if ( egl_mbox_trypost(epub->user_evt_mbox, (void*)msg) != 0)
                        printf("target_on msg post error.");
        }
}

void sip_handle_bootup(struct esp_sip *sip, struct sip_evt_bootup2 *bootup_evt)
{
        struct esp_pub *epub = (struct esp_pub *)EpubAddr; 
//printf("scan_status: %d \n", *scan_status);


        // Throw out  msg;
        if( epub->user_evt_mbox )
        {
                struct user_msg  *msg = (struct user_msg *)egl_malloc(sizeof(struct user_msg));
                msg->id = 12;
                msg->len = ETH_ALEN;
                msg->data = (u8 *)egl_malloc(msg->len);
                memcpy(msg->data, bootup_evt->mac_addr, msg->len);
                 if ( egl_mbox_trypost(epub->user_evt_mbox, (void*)msg) != 0)
                        printf("bootup msg post error.");
        }
}














void sip_handle_scan_complete(struct esp_sip *sip, u8 *scan_status)
{
        struct esp_pub *epub = (struct esp_pub *)EpubAddr; 
printf("scan_status: %d \n", *scan_status);

//Innerr handle....  

        
         // Throw out  msg;
        if( epub->user_evt_mbox )
        {
                struct user_msg  *msg = (struct user_msg *)egl_malloc( sizeof(struct user_msg) );
                msg->id = 1;
                msg->len = sizeof(u8);
                msg->data = (u8 *)egl_malloc(msg->len);
                memcpy(msg->data,scan_status,msg->len);
                 if ( egl_mbox_trypost(epub->user_evt_mbox, (void*)msg) != 0)
                        printf("scan_complete msg post error.");
        }
}

void sip_handle_bssinfo(struct esp_sip *sip, struct sip_evt_bssinfo *bssinfo)
{
        struct esp_pub *epub = (struct esp_pub *)EpubAddr; 
//printf("scan_status: %d \n", *scan_status);


#if 1
        // Throw out  msg;
        if( epub->user_evt_mbox )
        {
                struct user_msg  *msg = (struct user_msg *)egl_malloc( sizeof(struct user_msg) );
                msg->id = 2;
                msg->len = sizeof(struct sip_evt_bssinfo);
                msg->data = (u8 *)egl_malloc(msg->len);
                memcpy(msg->data,bssinfo,msg->len);
                if ( egl_mbox_trypost(epub->user_evt_mbox, (void*)msg) != 0)
                        printf("bssinfo msg post error.");
        }
#endif
}

void sip_handle_connect(struct esp_sip *sip, struct sip_evt_connect *connect)
{
        struct esp_pub *epub = (struct esp_pub *)EpubAddr; 
//printf("scan_status: %d \n", *scan_status);



        // Throw out  msg;
        if( epub->user_evt_mbox )
        {
                 // Throw out  msg;
                struct user_msg  *msg = (struct user_msg *)egl_malloc( sizeof(struct user_msg) );
                msg->id = 3;
                msg->len = sizeof(struct sip_evt_connect);
                msg->data = (u8 *)egl_malloc(msg->len);
                memcpy(msg->data,connect,msg->len);
                if ( egl_mbox_trypost(epub->user_evt_mbox, (void*)msg) != 0)
                        printf("connect msg post error.");
        }
}

void sip_handle_disconnect(struct esp_sip *sip, struct sip_evt_disconnect *disconnect)
{
        struct esp_pub *epub = (struct esp_pub *)EpubAddr; 
//printf("scan_status: %d \n", *scan_status);



        // Throw out  msg;
        if( epub->user_evt_mbox )
        {
                struct user_msg  *msg = (struct user_msg *)egl_malloc( sizeof(struct user_msg) );
                msg->id = 4;
                msg->len = sizeof(struct sip_evt_disconnect);
                msg->data = (u8 *)egl_malloc(msg->len);
                memcpy(msg->data,disconnect,msg->len);
                if ( egl_mbox_trypost(epub->user_evt_mbox, (void*)msg) != 0)
                        printf("disconnect msg post error.");
        }
}







/*************target ***********************/


/*send cmd to target, if aborted is true, inform target stop scan, report scan complete imediately
  return 1: complete over, 0: success, still have next scan, -1: hardware failure
  */
  
int sip_send_scan(struct sip_cmd_scan *scan_cmd)
{
        struct esp_pub *epub = (struct esp_pub *)EpubAddr;  
        return sip_cmd( epub, SIP_CMD_START_SCAN, (u8 *)scan_cmd, sizeof(struct sip_cmd_scan) );
}

int sip_send_config(struct sip_cmd_config *config_cmd)
{
        struct esp_pub *epub = (struct esp_pub *)EpubAddr;  

       // printf("config center freq %d\n",conf->channel->center_freq);
        
        return sip_cmd( epub, SIP_CMD_CONFIG, (u8 *)config_cmd, sizeof(struct sip_cmd_config) );
}

int sip_send_connect_to_ap(struct sip_cmd_connect *connect_to_ap_cmd)
{
        struct esp_pub *epub = (struct esp_pub *)EpubAddr;  
        
        connect_to_ap_cmd->networkType = 0;
        
        return sip_cmd( epub, SIP_CMD_CONNECT, (u8 *)connect_to_ap_cmd, sizeof(struct sip_cmd_connect) );
}


int sip_send_discon_from_ap(void)
{
        struct esp_pub *epub = (struct esp_pub *)EpubAddr;  
        //struct sip_cmd_connect_to_ap  connect_to_ap_cmd;
        
        return sip_cmd( epub, SIP_CMD_DISCONNECT, NULL, 0 );
}


int sip_send_ap_profile_commit(struct sip_cmd_connect *ap_profile_commit_cmd)
{
        struct esp_pub *epub = (struct esp_pub *)EpubAddr;  
        
        ap_profile_commit_cmd->networkType = 2;
        
        return sip_cmd( epub, SIP_CMD_AP_CONFIG_COMMIT, (u8 *)ap_profile_commit_cmd, sizeof(struct sip_cmd_connect) );
}



int sip_send_reset(void)
{
        struct esp_pub *epub = (struct esp_pub *)EpubAddr;  
        return sip_cmd( epub, SIP_CMD_RESET, NULL, 0 );
}







int sip_cmd(struct esp_pub *epub, enum sip_cmd_id cmd_id, u8 *cmd_buf, u8 cmd_len)
{
        int ret = 0;
       struct sk_buff *skb = NULL;

	skb = sip_alloc_ctrl_skbuf(epub->sip, cmd_len + sizeof(struct sip_hdr), cmd_id);
	if (!skb)
		return -1;

	memcpy(skb->data + sizeof(struct sip_hdr), cmd_buf, cmd_len);

/* 
        printf("skb addr:%x\n",&(skb->ListLink));
        A_NETBUF_QUEUE_T *dl_temp;
        int i = 0;
        for(dl_temp = epub->txq.pNext; i<8; dl_temp = dl_temp->pNext )
        {
            printf("%x,",dl_temp);
            i++;
        }
   */
   
        ret = sip_cmd_enqueue(epub->sip, skb);
        return ret;
}


