/*
 * Copyright (c) 2011 Espressif System.
 *
 *     MAC80211 support module
 */
#include <stdio.h>
#include <stdlib.h>
#include "sys/egl_sys_arch.h"

#include "esp_pub.h"
#include "egl_netbuf.h"

#include "linux_inc\net\cfg80211.h"
#include "linux_inc\net\mac80211.h"

#include "sip2_common.h"
#include "esp_ctrl.h"
#include "esp_utils.h"

extern void *EpubAddr;
struct {
        void *mbox;
        int  mbox_size;
        void *p_netif;
} UserPara = {NULL, 0, NULL};

extern int TXQueueWorkFlag ;
extern egl_sem_t QueueWorkCntSem;

/******************ݵķ****************************/
int esp_op_tx( struct sk_buff *skb)
{
        struct esp_pub *epub = (struct esp_pub *)EpubAddr;  

        //ESP_IEEE80211_DBG(ESP_DBG_LOG, "%s enter\n", __func__);
       // printf("esp_op_tx enter\n");
        memset(IEEE80211_SKB_CB(skb), 0, sizeof(struct ieee80211_tx_info));   //Clear skb flags.  Avoid skb->flag being 0xffffffff.
#if 0        
        if (!mod_support_no_txampdu() && hw->conf.channel_type != NL80211_CHAN_NO_HT) 
        {
                struct ieee80211_tx_info * tx_info = IEEE80211_SKB_CB(skb);
                struct ieee80211_hdr * wh = (struct ieee80211_hdr *)skb->data;
                if(ieee80211_is_data_qos(wh->frame_control)) 
                {
                        if(!(tx_info->flags & IEEE80211_TX_CTL_AMPDU)) 
                        {
                                u8 tidno = ieee80211_get_qos_ctl(wh)[0] & IEEE80211_QOS_CTL_TID_MASK;
                                struct ieee80211_sta *sta = tx_info->control.sta;
                                struct esp_node * node = (struct esp_node *)sta->drv_priv;
                                struct esp_tx_tid *tid = &node->tid[tidno];
                                //record ssn
                                spin_lock_bh(&epub->tx_ampdu_lock);
                                tid->ssn = GET_NEXT_SEQ(le16_to_cpu(wh->seq_ctrl)>>4);
                                ESP_IEEE80211_DBG(ESP_DBG_TRACE, "tidno:%u,ssn:%u\n", tidno, tid->ssn);
                                //start session
                                /*
                                if(tid->state == ESP_TID_STATE_INIT && (tid->ssn > 20)){
                                	tid->state = ESP_TID_STATE_TRIGGER;
                                	ESP_IEEE80211_DBG(ESP_DBG_ERROR, "start tx ba session,addr:%pM,tid:%u\n", wh->addr1, tidno);
                                	ieee80211_start_tx_ba_session(hw, wh->addr1, tidno);
                                }
                                */
                                spin_unlock_bh(&epub->tx_ampdu_lock);
                        } 
                        else 
                        {
                                ESP_IEEE80211_DBG(ESP_DBG_TRACE, "tx ampdu pkt, sn:%u, %u\n", le16_to_cpu(wh->seq_ctrl)>>4, skb->len);
                        }
                }
        }
#endif
/*
#ifdef GEN_ERR_CHECKSUM
        esp_gen_err_checksum(skb);
#endif
*/
        if ( sip_tx_data_pkt_enqueue(epub, skb) != 0 )
            return -1;

        if (epub)
        {
              TXQueueWorkFlag++;
               //egl_sem_signal(&QueueWorkCntSem);
         }
        	//ieee80211_queue_work(hw, &epub->tx_work);
        return 0;
}




/******************ķ****************************/

//----------- Below is for station add/remove
static int esp_node_attach(u8 ifidx, struct ieee80211_sta *sta)
{
       struct esp_pub *epub = (struct esp_pub *)EpubAddr;  
       struct esp_node *node = (struct esp_node *)sta->drv_priv;
        u8 tidno;
        struct esp_tx_tid *tid;
	int i;
	//spin_lock_bh(&epub->tx_ampdu_lock);
        for(tidno = 0, tid = &node->tid[tidno]; tidno < WME_NUM_TID; tidno++) 
        {
                tid->ssn = 0;
                tid->state = ESP_TID_STATE_INIT;
        }

	if(hweight32(epub->enodes_maps[ifidx]) <= ESP_PUB_MAX_STA && (i = ffz(epub->enodes_map)) < ESP_PUB_MAX_STA + 1)
       {
		epub->enodes_map |= (1 << i);
		epub->enodes_maps[ifidx] |= (1 << i);
        	epub->enodes[i] = node;
		node->sta = sta;
		node->ifidx = ifidx;
		node->index = i;
	} 
       else 
       {
		i = -1;
	}
	//spin_unlock_bh(&epub->tx_ampdu_lock);
	printf("epub->enodes_map:%x,enodes_maps[ifidx]:%x\n",epub->enodes_map, epub->enodes_maps[ifidx] );
	return i;
}

static int esp_node_detach(u8 ifidx, struct ieee80211_sta *sta)
{
       struct esp_pub *epub = (struct esp_pub *)EpubAddr;  
	u8 map;
	int i;
    
	//spin_lock_bh(&epub->tx_ampdu_lock);
	map = epub->enodes_maps[ifidx];
	while(map != 0)
       {
		i = ffs(map) - 1;
		if(epub->enodes[i]->sta == sta)
              {
			epub->enodes[i]->sta = NULL;
			epub->enodes[i] = NULL;
			epub->enodes_map &= ~(1 << i);
			epub->enodes_maps[ifidx] &= ~(1 << i);
			
			//spin_unlock_bh(&epub->tx_ampdu_lock);
			printf("epub->enodes_map:%x,enodes_maps[ifidx]:%x\n",epub->enodes_map, epub->enodes_maps[ifidx] );
			return i;
		  }
		  map &= ~(1 << i);
	}

	//spin_unlock_bh(&epub->tx_ampdu_lock);
	return -1;
}

int esp_op_sta_add(struct ieee80211_vif *vif, struct ieee80211_sta *sta)
{
       struct esp_pub *epub = (struct esp_pub *)EpubAddr;  
	struct esp_vif *evif = (struct esp_vif *)vif->drv_priv;
	int index;

	//ESP_IEEE80211_DBG(ESP_DBG_OP, "%s enter, vif addr %pM, sta addr %pM\n", __func__, vif->addr, sta->addr);
       //printf("op_sta_add enter, vif addr %pM, sta addr %pM\n"vif->addr, sta->addr);
	//add a connect in target
	
	index = esp_node_attach( evif->index, sta);
	
	if(index < 0)
		return -1;
        
	if (vif->p2p || vif->type != NL80211_IFTYPE_STATION)
		return 0;

        return 0;
}

int esp_op_sta_remove(struct ieee80211_vif *vif, struct ieee80211_sta *sta)
{	
       struct esp_pub *epub = (struct esp_pub *)EpubAddr;  
	struct esp_vif *evif = (struct esp_vif *)vif->drv_priv;
	int index;

	//remove a connect in target
	index = esp_node_detach(evif->index, sta);

	if (vif->p2p || vif->type != NL80211_IFTYPE_STATION)
		return 0;

        return 0;
}



/******************MAc ʼ***************************/

int esp_op_start(void)
{
        struct esp_pub *epub = (struct esp_pub *)EpubAddr;  
        epub->wl.off = 0;
}

void esp_op_stop(void)
{

}

int esp_ini_user_para(void *p_para, int size, u8 flag)
{
        if(flag == 1)
        {
                UserPara.mbox = p_para; 
                UserPara.mbox_size = size;
                 if (egl_mbox_new( (egl_mbox_t *) UserPara.mbox, UserPara.mbox_size ) != 0)
                            printf("user evt mbox creat failure\n");
        }
        if(flag == 2)
        {
                UserPara.p_netif =  p_para;
        }
        return 0;
}


struct esp_pub * esp_pub_alloc_mac80211(void)
{
        char i;
        struct esp_pub *epub;
        int ret = 0;
        struct ieee80211_channel * home_channel;
    
        epub = ( struct esp_pub * )egl_malloc( sizeof(struct esp_pub) );
        home_channel = (struct ieee80211_channel*)egl_malloc( sizeof(struct ieee80211_channel) );

home_channel->center_freq = 2412;
epub->conf.channel = home_channel;
epub->vif_slot = 0x00;
epub->enodes_map = 0; 
for(i = 0; i< ESP_PUB_MAX_VIF; i++)
        epub->enodes_maps[i] = 0;

        A_NETBUF_QUEUE_INIT(&epub->txq);
       // A_NETBUF_QUEUE_INIT(&epub->txdoneq);
       // A_NETBUF_QUEUE_INIT(&epub->rxq);

        egl_mutex_new( &(epub->tx_mtx) );

        epub->user_evt_mbox = (egl_mbox_t *) UserPara.mbox;

        if(epub->user_evt_mbox != NULL)
        {
               // if (egl_mbox_new(epub->user_evt_mbox, UserPara.mbox_size) != 0)
                    printf("user evt mbox is inserted\n");
        }
        else
            printf("user evt mbox is null\n");

        epub->p_netif =  UserPara.p_netif;
        if(epub->p_netif != NULL)
            printf("user netif is inserted,addr:%x\n",epub->p_netif);
        else
            printf("user netif is null\n");
        
        return epub;
}


