/*
 * Copyright (c) 2011-2012 Espressif System.
 */

#ifndef _ESP_UTILS_H_
#define _ESP_UTILS_H_

#include "sip2_common.h"

#ifndef BIT
#define BIT(x) (0x1 << (x))
#endif

unsigned int hweight32(unsigned int w);
#if 1
unsigned int esp_ieee2mhz(unsigned char chan);

enum ieee80211_key_alg {
        ALG_WEP,
        ALG_TKIP,
        ALG_CCMP,
        ALG_AES_CMAC
};

//int esp_cipher2alg(int cipher);

//void esp_rx_checksum_test(struct sk_buff *skb);
//void esp_gen_err_checksum(struct sk_buff *skb);
//bool esp_is_ip_pkt(struct sk_buff *skb);

#endif

#define  roundup(x, y)  (x%y)!=0 ? (x/y+1)*y:x

/*   this function : 
jude if the @nr bit of variable at @addr  is set or not, if set, return 1, else return 0; 
*/
static inline int test_bit(int nr, const volatile unsigned long *addr)
{
        return ((1 << (nr & 31)) & (addr[nr >> 5])) != 0;
}




/*
 * _ffs - find set bits total number in word. exam:0xee, ffs->6
 */
static inline unsigned long __ffs(unsigned long word)
{
	int num = 0;
    
	if ((word & 0xffffffff) == 0) {
		num += 32;
		word >>= 32;
	}
	if ((word & 0xffff) == 0) {
		num += 16;
		word >>= 16;
	}
	if ((word & 0xff) == 0) {
		num += 8;
		word >>= 8;
	}
	if ((word & 0xf) == 0) {
		num += 4;
		word >>= 4;
	}
	if ((word & 0x3) == 0) {
		num += 2;
		word >>= 2;
	}
	if ((word & 0x1) == 0)
		num += 1;
	return num;
}
/*
 * ffz - find first zero bit position in word. from 0 to 7, exam:0x57, ffz->3
 * @word: The word to search
 *
 * Undefined if no zero exists, so code should check against ~0UL first.
 */
#define ffz(x)  __ffs(~(x))


/*
 * ffs: find first bit set. This is defined the same way as
 * the libc and compiler builtin ffs routines, therefore
 * differs in spirit from the above __ffs.
 */

static inline int ffs(int word)
{
	int result = __ffs(word) + 1;
	return word ? result : 0;
}
#endif
