#ifndef PORT_ARCH_H
#define PORT_ARCH_H

#include "FreeRTOS.h"
#include "task.h"
#include "queue.h"
#include "semphr.h"
#include "timers.h"

#define EGL_MBOX_NULL					( ( xQueueHandle ) NULL )
#define EGL_SEM_NULL					( ( xSemaphoreHandle ) NULL )

#define EGL_DEFAULT_THREAD_STACK_DEPTH	configMINIMAL_STACK_SIZE

typedef xSemaphoreHandle egl_sem_t;
typedef xSemaphoreHandle egl_mutex_t;
typedef xQueueHandle egl_mbox_t;
typedef xTaskHandle egl_thread_t;
typedef xTimerHandle  egl_timer_t;

#define egl_mbox_valid( x ) ( ( ( *x ) == NULL) ? pdFALSE : pdTRUE )
#define egl_mbox_set_invalid( x ) ( ( *x ) = NULL )
#define egl_sem_valid( x ) ( ( ( *x ) == NULL) ? pdFALSE : pdTRUE )
#define egl_sem_set_invalid( x ) ( ( *x ) = NULL )


#endif