#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "sys/egl_sys_arch.h"
#include "bus/egl_bus_hw.h"
#include "spi_cfg.h"

//u8 temp[512];
//u8 tx_cmd[6];
//u8 rx_cmd[30];
u8 *temp;
u8 *tx_cmd;
u8 *rx_cmd;
        
egl_mutex_t BusHostMutex;
egl_sem_t BusIrqReadSem;

/*
1 SPI/NVIC_GPIO,NVIC,DMA,SPI hardware ini.
2 SPI bus cmd ini.
3 BusHoldMutex ini.
4 BusIrqReadSem ini.
*/
void bus_ini(void)
{
        SpiHwIni();
        egl_delay(5);
        SpiProtocolIni();

        if( egl_mutex_new(&BusHostMutex)==0)
        {
                printf("BusHostMutex ini,ok\n");
        }
        if( egl_sem_new(&BusIrqReadSem,0)==0)
        {
                printf("BusIrqReadSem ini,ok\n");
        }
       // temp = (u8 *)egl_malloc(512);
         temp = (u8 *)egl_malloc(512);
         tx_cmd = temp;
         rx_cmd = temp;
         printf("temp addr: %x\n",temp);
}

void bus_claim_host(void )
{
        egl_mutex_lock(&BusHostMutex);
}


void bus_release_host(void)
{
        egl_mutex_unlock(&BusHostMutex);
}


void bus_irq_en(u8 enable)
{
        SpiIrqEnable( enable );
}

 u8 BusReadReg(u32 addr, int *err_ret )
{

        tx_cmd[0]=0x74;

        if( addr >= (1<<17) )
        {
                *err_ret = 1;
                return 0;
        }
        else
        {
                tx_cmd[1]=0x10|0x00|(addr>>15);    
                tx_cmd[2]=addr>>7;    

                tx_cmd[3]=( addr<<1 );
                tx_cmd[4]= 0x00;    
        }
        
        tx_cmd[5]=0x01;

        STSpiWrite(tx_cmd,6);
                //printf("CMD52 Read \n");


#if 0
//Response read
        memset(rx_cmd,0xFF,20);
        ST_Spi_Read(rx_cmd,20);  
        
        //printf("Data Read :");     
        for(i=0;i<20;i++)
        {
            printf("%X,",rx_cmd[i]);
        }
        printf("\n");
        return 0;
 #else

 //Read Response.        
        do
        {
                rx_cmd[0]=0xFF;
                STSpiRead(rx_cmd,1);
         }while(rx_cmd[0]==0xFF);
        rx_cmd[1]=0xFF;
                STSpiRead(rx_cmd+1,1);

        if(rx_cmd[0]!=0)
            *err_ret = 2;
        else
            *err_ret = 0;
        return rx_cmd[1];        
 #endif



}


int BusWriteReg(u32 addr, u8 value)
{
        tx_cmd[0]=0x74;

        if( addr >= (1<<17) )
        {
                return 1;
        }
        else
        {
                tx_cmd[1]=0x90|0x00|(addr>>15);    //0x94;
                tx_cmd[2]=addr>>7;    

                tx_cmd[3]=( addr<<1 );
                tx_cmd[4]= value;
        }
        
        tx_cmd[5]=0x01;
        STSpiWrite(tx_cmd,6);
                //printf("CMD52 <Write config> stauts=16 \n");


#if 0
        memset(rx_cmd,0xFF,20);
                ST_Spi_Read(rx_cmd,20);

        for(i=0;i<15;i++)
        {
            printf("%X,",rx_cmd[i]);
        }
        printf("\n"); 
        return 0;
#else

        do
        {
                rx_cmd[0]=0xFF;
                STSpiRead(rx_cmd,1);
         }while(rx_cmd[0]==0xFF);
        rx_cmd[1]=0xFF;
                STSpiRead(rx_cmd+1,1);

         if( rx_cmd[1]!=value )    
         {
                printf("Write error,%X,%X", rx_cmd[0],rx_cmd[1]);
                return 2;
         }

        return 0;
        
#endif
//Read Response.        

}




/**
 *	sdio_writesb - write to a FIFO of a SDIO function
 *	@func: SDIO function to access
 *	@addr: address of (single byte) 
 *	@src: buffer that contains the data to write
 *	@count: number of bytes to write
 *
 *	Writes to the specified FIFO of a given SDIO function. Return
 *	value indicates if the transfer succeeded or not.
 */
 
int BusWriteBytes(u32 addr, void *src,u32 count)
{
        u8 *rx_data = (unsigned char*)src;
       
         if(count > 512 )
        {
                return 2;
        }
        
        tx_cmd[0]=0x75;

        if( addr >= (1<<17) )
        {
                return 1;
        }
        else
        {
             tx_cmd[1]=0x90|0x04|(addr>>15);    //0x94;
             tx_cmd[2]=addr>>7;    

            if(count > 512 )
            {
                return 2;
            }
            else if(count == 512 )
            {
                    tx_cmd[3]=( addr<<1|0x0 );
                    tx_cmd[4]= 0x00;     //0x08;
            }
            else
            {
                    tx_cmd[3]=( addr<<1|count>>7 );
                    tx_cmd[4]= count;     //0x08;
            }
        }
        
        tx_cmd[5]=0x01;
        STSpiWrite(tx_cmd,6);
                //printf("CMD53 <Write config> stauts=16 \n");
                
//Read Response.        
        do
        {
                rx_cmd[0]=0xFF;
                STSpiRead(rx_cmd,1);
         }while(rx_cmd[0]==0xFF);
        rx_cmd[1]=0xFF;
                STSpiRead(rx_cmd+1,1);
                
/*
        for(i=0;i<4;i++)
        {
            printf("%X,",rx_cmd[i]);
        }
        printf("\n");       
*/

//Send Start Token 
        tx_cmd[0]=0xFE;
        STSpiWrite(tx_cmd,1);
//Send buff
        memcpy(temp,rx_data,count);
        STSpiWrite(temp,count);
                 //printf("CMD53 Write data <Start Token>  stauts=17 \n");
                 
#if 1                
//Read Write done Response until not busy
        do
        {
                rx_cmd[0]=0xFF;
                STSpiRead(rx_cmd,1);
         }while(rx_cmd[0]!=0xE5);
                   
        //Read until not busy
        do
        {
                rx_cmd[0]=0xFF;
                STSpiRead(rx_cmd,1);
         }while( !(rx_cmd[0]&0x01) );
                
         // Not busy and still read two more bytes.             
         memset(rx_cmd,0xFF,2);
                STSpiRead(rx_cmd,2);      
#else
        memset(rx_cmd,0xFF,20);
                ST_Spi_Read(rx_cmd,20);

        for(i=0;i<20;i++)
        {
            printf("%X,",rx_cmd[i]);
        }
        printf("\n");  
#endif

        return 0;
}

/**
 *	sdio_memcpy_toio - write a chunk of memory to a SDIO function
 *	@func: SDIO function to access
 *	@addr: address to start writing to
 *	@src: buffer that contains the data to write
 *	@count: number of blocks to write
 *
 *	Writes to the address space of a given SDIO function. Return
 *	value indicates if the transfer succeeded or not.
 */
int BusWriteBlocks(u32 addr,void *src, u32 count)
{
        u8 j;
        u8 *rx_data = (unsigned char*)src;
        //unsigned char temp[SPI_BLOCK_SIZE];

        tx_cmd[0]=0x75;

        if( addr >= (1<<17) )
        {
                return 1;
        }
        else
        {
             tx_cmd[1]=0x90|0x0C|(addr>>15);   
             tx_cmd[2]=addr>>7;    

            if(count > 512 )
            {
                return 2;
            }
            else if(count >= 512 )
            {
                    tx_cmd[3]=( addr<<1|0x0 );
                    tx_cmd[4]= 0x00;     
            }
            else
            {
                    tx_cmd[3]=( addr<<1|count>>7 );
                    tx_cmd[4]= count;     
            }
        }
        tx_cmd[5]=0x01;

                //printf("CMD53 Block <Write config> \n");
        STSpiWrite(tx_cmd,6);
                
//Read Response.        
        do
        {
                rx_cmd[0]=0xFF;
                STSpiRead(rx_cmd,1);
         }while(rx_cmd[0]==0xFF);
        rx_cmd[1]=0xFF;
                STSpiRead(rx_cmd+1,1);
                
      
        for(j=0;j<count;j++)
        {
//Send Start Token 
                tx_cmd[0]=0xFC;
                STSpiWrite(tx_cmd,1);
//Send block
                memcpy(temp,rx_data+j*BLOCK_SIZE,BLOCK_SIZE);
                STSpiWrite( temp,BLOCK_SIZE );
                         //printf("CMD53 Block <Write Done> response \n");
#if 1
//Read data response       
                do
                {
                        rx_cmd[0]=0xFF;
                        STSpiRead(rx_cmd,1);
                 }while(rx_cmd[0]!=0xE5);
//Read until not busy
                do
                {
                        rx_cmd[0]=0xFF;
                        STSpiRead(rx_cmd,1);
                 }while( !(rx_cmd[0]&0x01) );
                
// Not busy and still read two more bytes.    
                memset(rx_cmd,0xFF,2);
                STSpiRead(rx_cmd,2);   
#else
                    memset(rx_cmd,0xFF,20);
                            ST_Spi_Read(rx_cmd,20);

                    for(i=0;i<20;i++)
                    {
                        printf("%X,",rx_cmd[i]);
                    }
                    printf("\n");  
#endif
        };
        

//Send Stop Token       
        tx_cmd[0]=0xFD;
        STSpiWrite(tx_cmd,1);
        
                //printf("CMD53 Block <Stop Token> response \n");
#if 1                
//Read until busy reponse occur   
       do
        {
                rx_cmd[0]=0xFF;
                 STSpiRead(rx_cmd,1);
        }while( rx_cmd[0]==0xFF );

//Read until not busy 
        do
        {
                rx_cmd[0]=0xFF;
                 STSpiRead(rx_cmd,1);
        }while( !(rx_cmd[0]&0x01) );
// Not busy and still read two more bytes.    
        memset(rx_cmd,0xFF,2);
        STSpiRead(rx_cmd,2); 
#else
        memset(rx_cmd,0xFF,20);
                ST_Spi_Read(rx_cmd,20);

        for(i=0;i<20;i++)
        {
            printf("%X,",rx_cmd[i]);
        }
        printf("\n");  
#endif

        return 0;
}


/**
 *	sdio_readsb - read from a FIFO on a SDIO function
 *	@func: SDIO function to access
 *	@dst: buffer to store the data
 *	@addr: address of (single byte) FIFO  addr:0~0xfffff
 *	@count: number of bytes to read        count<=512
 *
 *	Reads from the specified FIFO of a given SDIO function. Return
 *	value indicates if the transfer succeeded or not.
 */  
int BusReadBytes(u32 addr, void *dst, u32 count)
{
        u8 *rx_data = (unsigned char *)dst;
        
        tx_cmd[0]=0x75;

        if( addr >= (1<<17) )
        {
                return 1;
        }
        else
        {
             tx_cmd[1]=0x10|0x04|(addr>>15);    //0x94;
             tx_cmd[2]=addr>>7;    

            if(count > 512 )
            {
                return 2;
            }
            else if(count == 512 )
            {
                    tx_cmd[3]=( addr<<1|0x0 );
                    tx_cmd[4]= 0x00;     //0x08;
            }
            else
            {
                    tx_cmd[3]=( addr<<1|count>>7 );
                    tx_cmd[4]= count;     //0x08;
            }
        }
        
        tx_cmd[5]=0x01;
/*
        printf("CMD53 Read:");
        for(i=0;i<6;i++)
        {
            printf("%X,",tx_cmd[i]);
        }
        printf("\n");
*/     
        STSpiWrite(tx_cmd,6);
                //printf("CMD53 Read config stauts=15 \n");


#if 0
//Response read
        memset(rx_cmd,0xFF,20);
        ST_Spi_Read(rx_cmd,20);  
        
        printf("Data Read :");     
        for(i=0;i<20;i++)
        {
            printf("%X,",rx_cmd[i]);
        }
        printf("\n");
 #else

 //Read Response.        
        do
        {
                rx_cmd[0]=0xFF;
                STSpiRead(rx_cmd,1);
         }while(rx_cmd[0]==0xFF);
        rx_cmd[1]=0xFF;
                STSpiRead(rx_cmd+1,1);
                
//Token read
        do
        {
                rx_cmd[0]=0xFF;
                STSpiRead(rx_cmd,1);
        }while(rx_cmd[0]!=0xFE) ;  

//Data read        
        memset(rx_data,0xFF,count);
        STSpiRead(rx_data,count);  
        
//CRC Read
        rx_cmd[0]=0xFF;    rx_cmd[1]=0xFF;
        STSpiRead(rx_cmd,2);   

 #endif

        return 0;
}


/**
 *	sdio_memcpy_fromio - read a chunk of memory from a SDIO function
 *	@func: SDIO function to access
 *	@dst: buffer to store the data
 *	@addr: address to begin reading from
 *	@count: number of bytes to read
 *
 *	Reads from the address space of a given SDIO function. Return
 *	value indicates if the transfer succeeded or not.
 */
int BusReadBlocks(u32 addr, void *dst, u32 count)
{
       u8 j;
       u8 *rx_data = (unsigned char *)dst;
               
        tx_cmd[0]=0x75;

        if( addr >= (1<<17) )
        {
                return 1;
        }
        else
        {
             tx_cmd[1]=0x10|0x0C|(addr>>15);   
             tx_cmd[2]=addr>>7;    

            if(count >= 512 )
            {
                    tx_cmd[3]=( addr<<1|0x0 );
                    tx_cmd[4]= 0x00;     
            }
            else
            {
                    tx_cmd[3]=( addr<<1|count>>7 );
                    tx_cmd[4]= count;     
            }
        }
        tx_cmd[5]=0x01;
        
                //printf("CMD53 Block <Read config> \n");

        STSpiWrite(tx_cmd,6);

#if 0                
//Read Response. 
        memset(rx_cmd,0xFF,30);
                ST_Spi_Read(rx_cmd,30);

        for(i=0;i<30;i++)
        {
            printf("%X,",rx_cmd[i]);
        }
        printf("\n");

#else         
//Read Response. 
        do
        {
                rx_cmd[0]=0xFF;
                STSpiRead(rx_cmd,1);
         }while(rx_cmd[0]==0xFF);
        rx_cmd[1]=0xFF;
                STSpiRead(rx_cmd+1,1);
/*                
        for(i=0;i<4;i++)
        {
            printf("%X,",rx_cmd[i]);
        }
        printf("\n");
*/             
                
        for(j=0;j<count;j++)
        {
//Read Token        
               do
               {
                    rx_cmd[0]=0xFF;
                    STSpiRead(rx_cmd,1);  
               }while(rx_cmd[0]!=0xFE);

//Read Block
               memset( (rx_data+j*BLOCK_SIZE),0xFF,BLOCK_SIZE);     
               STSpiRead(rx_data+j*BLOCK_SIZE, BLOCK_SIZE);
//Read CRC               
               rx_cmd[0]=0xFF;rx_cmd[1]=0xFF;
               STSpiRead(rx_cmd,2);
        }

#endif       
        return 0;

}


