/*
 * Copyright (c) 2012 Espressif System.
 */

//#include "wifi_user_interface.h"
#include <stdio.h>
#include <string.h>
#include "sys/egl_sys_arch.h"

#include "sip2_common.h"
#include "esp_ctrl.h"
#include "esp_pub.h"
#include "egl_netbuf.h"
//#include "port/wifi_user_interface.h"
#include "esp_debug.h"

/**************Ini&Deini*******************/
static int UpperLayerCanTx;

void UserAddMbox(void *mbox, int size)
{
        esp_ini_user_para(mbox, size, 1);
}

extern void ThreadMainProcess(void *pvParameters);
//void EglWifiIni( struct netif *netif )
void EglWifiIni( void *p_netif )
{
        UpperLayerCanTx = 1;
        esp_ini_user_para(p_netif, 0, 2);
        egl_thread_new( ( signed portCHAR * ) "WifiMainThread", ThreadMainProcess, NULL, 1024, 8) ;          //6
}



/**************User Cmds*******************/
void UserScan(void)
{
        struct sip_cmd_scan scan_cmd;

//add you cmd para here....




        printf("scan_cmd send\n");
        sip_send_scan(&scan_cmd);

}

void UserConToAP(void)
{
        struct sip_cmd_connect connect_to_ap_cmd;

//add you cmd para here....
#if 1
        connect_to_ap_cmd.authMode = 3;
        //connect_to_ap_cmd.channel_no = 11;
        connect_to_ap_cmd.dot11AuthMode = 0;
        connect_to_ap_cmd.networkType = 0;
        //connect_to_ap_cmd.bssid_set = 1;
#else
        connect_to_ap_cmd.authMode = 0;
        //connect_to_ap_cmd.channel_no = 11;
        connect_to_ap_cmd.dot11AuthMode = 0;
        connect_to_ap_cmd.networkType = 0;
        //connect_to_ap_cmd.bssid_set = 1;
#endif
        connect_to_ap_cmd.passphrase_len = 8;
        memcpy(connect_to_ap_cmd.passphrase ,"87654321",connect_to_ap_cmd.passphrase_len);

        connect_to_ap_cmd.ssidLength = 9;
        //memcpy(connect_to_ap_cmd.ssid ,"ASUS_3814cef2d88",connect_to_ap_cmd.ssidLength);
        //memcpy(connect_to_ap_cmd.ssid ,"TP-LINK-DYC",connect_to_ap_cmd.ssidLength);
        memcpy(connect_to_ap_cmd.ssid ,"dlink_dyc",connect_to_ap_cmd.ssidLength);
        
        //memcpy(connect_to_ap_cmd.bssid ,"123456",6);


        printf("connect_to_ap_cmd send\n");
        sip_send_connect_to_ap(&connect_to_ap_cmd);
}

void UserDisconFromAP(void)
{
        printf("disconnect_to_ap_cmd send\n");
        sip_send_discon_from_ap();
}

void UserSetUpAP(void)
{
        struct sip_cmd_connect ap_profile_commit_cmd;

//add you cmd para here....
        ap_profile_commit_cmd.authMode = 3;
        ap_profile_commit_cmd.networkType = 2;
        ap_profile_commit_cmd.channel_no = 11;
        ap_profile_commit_cmd.dot11AuthMode = 1;
        ap_profile_commit_cmd.bssid_set = 1;

        ap_profile_commit_cmd.passphrase_len = 5;
        memset(ap_profile_commit_cmd.passphrase,0,SIP_PASSPHRASE_LEN);
        memcpy(ap_profile_commit_cmd.passphrase ,"12345",ap_profile_commit_cmd.passphrase_len);

        ap_profile_commit_cmd.ssidLength = 7;
        memset(ap_profile_commit_cmd.ssid,0,SIP_MAX_SSID_LEN);
        memcpy(ap_profile_commit_cmd.ssid ,"esppppp",ap_profile_commit_cmd.ssidLength);

        memset(ap_profile_commit_cmd.bssid,0,SIP_MAC_LEN);
        memcpy(ap_profile_commit_cmd.bssid ,"123456",6);




        printf("ap_profile_commit_cmd send\n");
        sip_send_ap_profile_commit(&ap_profile_commit_cmd);
}

void UserReset(void)
{
        printf("reset_cmd send\n");
        sip_send_reset();
}

void UserSendConfig(void)
{
        struct sip_cmd_config configcmd;

//add you cmd para here....




        configcmd.center_freq= 2462;
        configcmd.duration= 0;
        printf("Send Config \n");
        sip_send_config(&configcmd);
}






/**************Data _tx_interface*******************/

void UpperLayerTxSwitch(u8 i)
{
//Add you data tx switch here.

        if(i)
        {
            UpperLayerCanTx = 1;       //start tx down
           // printf("s\n");
        }
        else
        {
            UpperLayerCanTx = 0;       //stop tx down
           // printf("p\n");
        }

}
int EglDataCanTX(void)
{
        return UpperLayerCanTx;
}

//NOTE: The skb should be free by user itself. 
int EglDataTx(struct sk_buff *skb)
{
        return esp_op_tx(skb);
}


//const int khead_room = sizeof(ATH_LLC_SNAP_HDR);
const int khead_room = 32;

// Upper layer please use this function to send data down.
int wlan_hard_start_xmit(u8* tx_buf, u32 len)
{
	skb_t *skb;
	skb = (skb_t *)egl_malloc(sizeof(skb_t));
	if (!skb)
	{
		egl_free(tx_buf);
		return 0;
	}
	skb->buf = tx_buf;
	//skb->data = tx_buf + khead_room;
	//skb->len = len - khead_room;
	skb->data = tx_buf ;
	skb->len = len ;
    
	return EglDataTx(skb);
}


/**************Data _rx_interface*******************/

extern void ethernetif_input(void *p_netif, u8 * buf, int len );
void EglDataRx(void *p_netif, struct sk_buff *skb)
{

//Add you data process funcs.

        if(skb)
        {
                ethernetif_input(p_netif, (u8*)A_NETBUF_DATA(skb), A_NETBUF_LEN(skb));
                A_NETBUF_FREE(skb);
        }
}























/**************Evt mbox handle example*******************/
int UserMboxCheck(void *mbox)
{
        if( mbox == NULL)
        {
                printf("user mbox is NULL");
                return -1;
        }
        
        // Throw out  msg;
        egl_mbox_t *user_mbox =(egl_mbox_t * )mbox;
        struct user_msg *msg;
        if( egl_mbox_tryfetch(user_mbox, (void **)&msg) == 0 )
        {
                printf("msg id: %d\n",msg->id);
                show_buf(msg->data, msg->len);
                egl_free(msg->data);
                egl_free(msg);
        }
        return 0;
}



