#include <stdio.h>
#include <string.h>

#include "FreeRTOS.h"
#include "task.h"
#if SPI_SUPPORT

#include "spi_cfg.h"

//Because of IRQ handle here, so include other h files
#include "bus/egl_bus_hw.h"   //Ony for a spi irq sem


//#define SPI1_DR_Address 0x4001300C
#define SPI2_DR_Address 0x4000380C
//#define SPI3_DR_Address    0x40003C0C

#define BIT_8 (1)


static int STSpi2Init(void);
static void STSpi2IrqtInit(void);

static void SPI2DMAConfiguration(DMA_Channel_TypeDef* DMAy_Channelx, int bufsize, unsigned char* dma_buf);
static int SPI2DMASendReceive(int buf_size, unsigned char* dma_buf);

static int STSpiSendCmd(unsigned char *cmd,unsigned char *resp,char resp_cnt);



/****************SPI,IRQӲʼ******************************/

static int STSpi2Init(void)
{

printf("SPI2  initilized \n ");

    	GPIO_InitTypeDef GPIO_InitStructure;
        
       RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1, ENABLE);  
             
        	//pg 7, wifi irq gpio
    	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7; 
    	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;  //
    	GPIO_Init(GPIOG, &GPIO_InitStructure);

       RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO|RCC_APB2Periph_GPIOB, ENABLE);

       /* SPI2 GPIO configuration ------------------------------------------------------*/
	/* Configure SPI2 pins: SCK and MOSI */    
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_13 | GPIO_Pin_15; 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_Init(GPIOB, &GPIO_InitStructure);
    
	/* Configure SPI2 pins: MISO */    
    	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_14 ; 
    	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;  //
    	GPIO_Init(GPIOB, &GPIO_InitStructure);

        //PB12 Eagle wifi CS,  PB12 not need clock
    	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12; 
    	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;  
    	GPIO_Init(GPIOB, &GPIO_InitStructure);


	/* SPI2 configuration ------------------------------------------------------*/

	RCC_APB1PeriphClockCmd(RCC_APB1Periph_SPI2 , ENABLE);

       SPI_Cmd(SPI2, DISABLE);     
        
        SPI_InitTypeDef SPI_InitStructure;
        
	SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
	SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
    
    #if BIT_8
	SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
    #else
	SPI_InitStructure.SPI_DataSize = SPI_DataSize_16b;
    #endif
    
	SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;
	SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;
	SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;

        
	SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_2;

	SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
	SPI_InitStructure.SPI_CRCPolynomial = 7;
	SPI_Init(SPI2, &SPI_InitStructure);
       SPI_SSOutputCmd(SPI2, ENABLE);       //?????
       SPI_Cmd(SPI2, ENABLE);

        return 0;
}

/*   Not use */
static void STSpi2IrqtInit(void)
{
	NVIC_InitTypeDef NVIC_InitStructure;
	EXTI_InitTypeDef EXTI_InitStructure;

	GPIO_EXTILineConfig(GPIO_PortSourceGPIOG, GPIO_PinSource7);

    	/* Configure Key Button EXTI Line to generate an interrupt on falling edge */  
	EXTI_InitStructure.EXTI_Line = EXTI_Line7;
	EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;
	EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Falling;//EXTI_Trigger_Falling;
	EXTI_InitStructure.EXTI_LineCmd = ENABLE;
	EXTI_Init(&EXTI_InitStructure);
    
        /* Connect Key Button EXTI Line to Key Button GPIO Pin */  
              // Set PG7 as interrupt source.   faling egle triger the INT. 
	NVIC_InitStructure.NVIC_IRQChannel = EXTI9_5_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 15;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure); 
#if 0
/* Configure one bit for preemption priority */
//NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);

/* Enable DMA channel5 IRQ Channel */
NVIC_InitStructure.NVIC_IRQChannel = DMA1_Channel5_IRQn;
NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 4;
NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
NVIC_Init(&NVIC_InitStructure);

/* Enable DMA channel4 IRQ Channel */
NVIC_InitStructure.NVIC_IRQChannel = DMA1_Channel4_IRQn;
NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 5;
NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
NVIC_Init(&NVIC_InitStructure);
#endif
}

DMA_InitTypeDef    DMA_InitStructure;
void SpiHwIni(void)
{
        STSpi2Init();//IOʼ
        //ֹSPI2 NRF24L01+Ƭѡ
	//GPIO_SetBits(GPIOB, GPIO_Pin_12);
	//һֱѡС
       GPIO_ResetBits(GPIOB, GPIO_Pin_12);
        
       SPI_I2S_DMACmd(SPI2, SPI_I2S_DMAReq_Rx, ENABLE);
       SPI_I2S_DMACmd(SPI2, SPI_I2S_DMAReq_Tx, ENABLE);
       
        DMA_InitStructure.DMA_PeripheralBaseAddr = (u32)(&(SPI2->DR));
        DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;
        DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;

#if BIT_8  
        DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte;
        DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte;
#else
        DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_HalfWord;
        DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_HalfWord;
#endif
        DMA_InitStructure.DMA_Mode = DMA_Mode_Normal;
        DMA_InitStructure.DMA_Priority = DMA_Priority_VeryHigh;       //DMA_Priority_High;
        DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;

       STSpi2IrqtInit();//SPIʹ
       SpiIrqEnable(1);
       
}



void SpiIrqEnable(unsigned char Enable)
{
	NVIC_InitTypeDef NVIC_InitStructure;

	if (Enable)
	{
		/* Enable the EXTI7 Interrupt */
		NVIC_InitStructure.NVIC_IRQChannel = EXTI9_5_IRQn;
		NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 15;
		NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
		NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
		NVIC_Init(&NVIC_InitStructure); 
	}
	else
	{
		/* Enable the EXTI7 Interrupt */
		NVIC_InitStructure.NVIC_IRQChannel = EXTI9_5_IRQn;
		NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 15;
		NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
		NVIC_InitStructure.NVIC_IRQChannelCmd = DISABLE;
		NVIC_Init(&NVIC_InitStructure); 
	}
}



static int ST_Spi2_Int_Status()
{
//return irq pin status
	return GPIO_ReadInputDataBit(GPIOG, GPIO_Pin_7);
}



/****************SPIշ******************************/

static void SPI2DMAConfiguration(DMA_Channel_TypeDef* DMAy_Channelx, int bufsize, unsigned char* dma_buf)
{
#if 0
        DMA_InitTypeDef    DMA_InitStructure;

        //DMA_InitStructure.DMA_PeripheralBaseAddr = (u32)SPI2_DR_Address;
        DMA_InitStructure.DMA_PeripheralBaseAddr = (u32)(&(SPI2->DR));

        DMA_InitStructure.DMA_BufferSize = bufsize;
        DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;
        DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;

#if BIT_8  
        //DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_HalfWord;
        DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte;
        DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte;
#else
        DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_HalfWord;
        DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_HalfWord;
#endif

        DMA_InitStructure.DMA_Mode = DMA_Mode_Normal;
        DMA_InitStructure.DMA_Priority = DMA_Priority_VeryHigh;       //DMA_Priority_High;
        DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;
#endif
        DMA_InitStructure.DMA_BufferSize = bufsize;
        if(DMAy_Channelx == DMA1_Channel4)	//for Rx
        {
                DMA_DeInit(DMA1_Channel4);
                DMA_InitStructure.DMA_MemoryBaseAddr = (u32)dma_buf;
                DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralSRC;
        }
        else	//for Tx
        {
                DMA_DeInit(DMA1_Channel5);  
                DMA_InitStructure.DMA_MemoryBaseAddr = (u32)dma_buf;
                DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralDST;
        }
        DMA_Init(DMAy_Channelx, &DMA_InitStructure);
}




static int SPI2DMASendReceive(int buf_size, unsigned char* dma_buf)
{

	unsigned int ticks;
//Enable  CS
	//GPIO_ResetBits(GPIOB, GPIO_Pin_12);
//printf("go 1\n");

	//DMA_Cmd(DMA1_Channel5, DISABLE);
       //DMA_Cmd(DMA1_Channel4, DISABLE);
       
       //DMA_ClearFlag(DMA1_FLAG_GL4|DMA1_FLAG_TC4|DMA1_FLAG_HT4|DMA1_FLAG_TE4);
       //DMA_ClearFlag(DMA1_FLAG_GL5|DMA1_FLAG_TC5|DMA1_FLAG_HT5|DMA1_FLAG_TE5);
       DMA_ClearFlag(DMA1_FLAG_TC5);
       
    	SPI2DMAConfiguration(DMA1_Channel4, buf_size, dma_buf);
       //SPI_I2S_DMACmd(SPI2, SPI_I2S_DMAReq_Rx, ENABLE);
               
	SPI2DMAConfiguration(DMA1_Channel5, buf_size, dma_buf);
       //SPI_I2S_DMACmd(SPI2, SPI_I2S_DMAReq_Tx, ENABLE);

       //DMA_ITConfig(DMA1_Channel5, DMA_IT_TC, ENABLE);        //DMAͨ1ж
       //DMA_ITConfig(DMA1_Channel4, DMA_IT_TC, ENABLE);        //DMAͨ1ж

       //SPI2->DR;               
       //while((SPI2->SR&1<<1)==0);

       DMA_Cmd(DMA1_Channel4, ENABLE);
       DMA_Cmd(DMA1_Channel5, ENABLE);

	ticks=0;
    
       //printf("t:%d\n",xTaskGetTickCount());
      
        while((DMA_GetFlagStatus(DMA1_FLAG_TC5) == RESET)&&(DMA_GetFlagStatus(DMA1_FLAG_TC4) == RESET)) 
  	//while( !DMA_GetFlagStatus(DMA1_FLAG_TC4)||!DMA_GetFlagStatus(DMA1_FLAG_TC5) )
	{
		ticks++;
		if( ticks > 0xffff )
		{
			printf("-WIFI SPI Error-");
			//GPIO_SetBits(GPIOB, GPIO_Pin_12);
                     DMA_Cmd(DMA1_Channel4, DISABLE);
                     DMA_Cmd(DMA1_Channel5, DISABLE);
			return 0;
		}
  	}

//printf("%d\n",ticks);
       DMA_Cmd(DMA1_Channel4, DISABLE);
       DMA_Cmd(DMA1_Channel5, DISABLE);

	//GPIO_SetBits(GPIOB, GPIO_Pin_12);
	return 1;
}

void DMA1_Channel5_IRQHandler(void)
{

        if(DMA_GetITStatus(DMA1_IT_TC5))
        {
                //printf("TC5 Flag:%d\n",DMA_GetFlagStatus(DMA1_IT_TC5));
                //DMA_ClearITPendingBit(DMA1_IT_GL5); //ȫжϱ־
                DMA_ClearITPendingBit(DMA1_IT_TC5);
        }
}

void DMA1_Channel4_IRQHandler(void)
{
        if(DMA_GetITStatus(DMA1_IT_TC4))
        {
                printf("TC4 Flag:%d\n",DMA_GetFlagStatus(DMA1_FLAG_TC4));
                //DMA_ClearITPendingBit(DMA1_IT_GL4); //ȫжϱ־
                DMA_ClearITPendingBit(DMA1_IT_TC4);
        }
}


int STSpiRead(unsigned char* Buf, int size)
{
	 SPI2DMASendReceive(size,Buf);
         return 0;
}
int STSpiWrite(unsigned char* Buf, int size)
{
	 SPI2DMASendReceive(size,Buf);
         return 0;
}



/****************SPIЭջĳʼ******************************/

static int STSpiSendCmd(unsigned char *cmd,unsigned char *resp,char resp_cnt)
{
       unsigned char i; 
//printf("go a\n");
       //STSpiWrite(cmd,6);
       STSpiWrite(cmd,6);
        
       memset(resp,0xFF,resp_cnt);
//printf("go b\n");      
       STSpiRead(resp,resp_cnt);
       
 #if 1
       for(i=0;i<resp_cnt;i++)
       {
            printf("%X,",resp[i]);
       }
       printf("\n");
#endif

       return 0;
}

void SpiProtocolIni(void)
{
unsigned char spi_proto_ini_status = 0;

unsigned char SPI2RxBuf[15];
unsigned char SPI2TxBuf[15];

printf("SPI2RxBuf add:%x, SPI2TxBuf:%x \n",&SPI2RxBuf,&SPI2TxBuf);

        do
        {             
                 if( spi_proto_ini_status == 0 )
                 {
                        do
                        { 
                                SPI2TxBuf[0]=0x40;
                                SPI2TxBuf[1]=0x00;
                                SPI2TxBuf[2]=0x00;
                                SPI2TxBuf[3]=0x00;
                                SPI2TxBuf[4]=0x00;
                                SPI2TxBuf[5]=0x95;
                                printf("CMD0 \n");
                                STSpiSendCmd(SPI2TxBuf,SPI2RxBuf,10);
                                //STSpiWrite(SPI2TxBuf,6);
                                vTaskDelay(1000);
                        }while( SPI2RxBuf[2] != 0x01 );
                        //}while( 1 );
                 }
                 else if( spi_proto_ini_status == 1 )
                {
                        SPI2TxBuf[0]=0x45;
                        SPI2TxBuf[1]=0x00;
                        SPI2TxBuf[2]=0x20;               //0x04;
                        SPI2TxBuf[3]=0x00;
                        SPI2TxBuf[4]=0x00;
                        SPI2TxBuf[5]=0x01;
                        printf("CMD 5 1st\n");
                        STSpiSendCmd(SPI2TxBuf,SPI2RxBuf,10);
                 }
                else if( spi_proto_ini_status == 2 )
                {
                        SPI2TxBuf[0]=0x45;
                        SPI2TxBuf[1]=0x00;
                        SPI2TxBuf[2]=0x20;               
                        SPI2TxBuf[3]=0x00;
                        SPI2TxBuf[4]=0x00;
                        SPI2TxBuf[5]=0x01;
                                                                printf("CMD5 2nd\n");
                        STSpiSendCmd(SPI2TxBuf,SPI2RxBuf,10);
                                    
                 }
                 else if( spi_proto_ini_status == 3 )                  //CMD 52   addr 0x2,   data 0x02;
                {
                        SPI2TxBuf[0]=0x74;
                        SPI2TxBuf[1]=0x80;
                        SPI2TxBuf[2]=0x00;               
                        SPI2TxBuf[3]=0x04;
                        SPI2TxBuf[4]=0x02;
                        SPI2TxBuf[5]=0x01;
                        printf("CMD52 Write  addr 02 \n");  
                        STSpiSendCmd(SPI2TxBuf,SPI2RxBuf,10);
                             
                 }
                else if( spi_proto_ini_status == 4 )           
                {
                        SPI2TxBuf[0]=0x74;
                        SPI2TxBuf[1]=0x80;
                        SPI2TxBuf[2]=0x00;               
                        SPI2TxBuf[3]=0x08;
                        SPI2TxBuf[4]=0x03;
                        SPI2TxBuf[5]=0x01;
                           printf("CMD52 Write  addr 04 \n"); 
                        STSpiSendCmd(SPI2TxBuf,SPI2RxBuf,10);
                                     
                 }
                 else if( spi_proto_ini_status == 5 )           
                {
                        SPI2TxBuf[0]=0x74;
                        SPI2TxBuf[1]=0x00;
                        SPI2TxBuf[2]=0x00;               
                        SPI2TxBuf[3]=0x04;
                        SPI2TxBuf[4]=0x00;
                        SPI2TxBuf[5]=0x01;
                         printf("CMD52 Read  addr 0x2 \n");
                        STSpiSendCmd(SPI2TxBuf,SPI2RxBuf,10);
                                      
                 }
                 else if( spi_proto_ini_status == 6 )           
                {
                        SPI2TxBuf[0]=0x74;
                        SPI2TxBuf[1]=0x00;
                        SPI2TxBuf[2]=0x00;               
                        SPI2TxBuf[3]=0x08;
                        SPI2TxBuf[4]=0x00;
                        SPI2TxBuf[5]=0x01;
                         printf("CMD52 Read addr 0x4 \n");
                        STSpiSendCmd(SPI2TxBuf,SPI2RxBuf,10);
                                      
                 }
                 else if (spi_proto_ini_status>6 && spi_proto_ini_status<15)
                {
                        SPI2TxBuf[0]=0x74;
                        SPI2TxBuf[1]=0x10;
                        SPI2TxBuf[2]=0x00;               
                        SPI2TxBuf[3]=0xF0+2*(spi_proto_ini_status-7);
                        SPI2TxBuf[4]=0x00;
                        SPI2TxBuf[5]=0x01;
                        STSpiSendCmd(SPI2TxBuf,SPI2RxBuf,10);
                 }
                else if (spi_proto_ini_status==15)
                {
#if 1
                                        printf("CMD52 Write  Reg addr 0x110 \n"); 
                        SPI2TxBuf[0]=0x74;
                        SPI2TxBuf[1]=0x80;              //func0 should be
                        SPI2TxBuf[2]=0x02;               
                        SPI2TxBuf[3]=0x20;
                        SPI2TxBuf[4]=(SPI_BLOCK_SIZE);                       //0x02;
                        SPI2TxBuf[5]=0x01;
                        STSpiSendCmd(SPI2TxBuf,SPI2RxBuf,10);
                        
                                        printf("CMD52 Write Reg addr 0x111 \n");  
                        SPI2TxBuf[0]=0x74;
                        SPI2TxBuf[1]=0x80;
                        SPI2TxBuf[2]=0x02;               
                        SPI2TxBuf[3]=0x22;
                        SPI2TxBuf[4]=(SPI_BLOCK_SIZE>>8);                      //0x00;
                        SPI2TxBuf[5]=0x01;
                        STSpiSendCmd(SPI2TxBuf,SPI2RxBuf,10);
#endif
                }
                else if (spi_proto_ini_status==16)
                {
#if 0                                                    
                        printf("CMD52 Write  Reg addr 0x40 \n"); 
                        SPI2TxBuf[0]=0x74;
                        SPI2TxBuf[1]=0x90;              
                        SPI2TxBuf[2]=0x00;               
                        SPI2TxBuf[3]=0x80;
                        SPI2TxBuf[4]=0x91;                         //0x91;
                        SPI2TxBuf[5]=0x01;
                        STSpiSendCmd(SPI2TxBuf,SPI2RxBuf,10);
                                                                
                
                        printf("CMD52 Write  Reg addr 0x3c \n"); 
                        SPI2TxBuf[0]=0x74;
                        SPI2TxBuf[1]=0x90;            
                        SPI2TxBuf[2]=0x00;               
                        SPI2TxBuf[3]=0x78;
                        SPI2TxBuf[4]=0x3f;                         //0x3f;                    
                        SPI2TxBuf[5]=0x01;
                        STSpiSendCmd(SPI2TxBuf,SPI2RxBuf,10);
                                                                printf("CMD52 Write  Reg addr 0x3d \n"); 

                        SPI2TxBuf[0]=0x74;
                        SPI2TxBuf[1]=0x90;              
                        SPI2TxBuf[2]=0x00;               
                        SPI2TxBuf[3]=0x7a;
                        SPI2TxBuf[4]=0x34;                        //0x34;
                        SPI2TxBuf[5]=0x01;
                        STSpiSendCmd(SPI2TxBuf,SPI2RxBuf,10);
                                                                printf("CMD52 Write  Reg addr 0x3e \n"); 
                                                                
                        SPI2TxBuf[0]=0x74;
                        SPI2TxBuf[1]=0x90;              
                        SPI2TxBuf[2]=0x00;               
                        SPI2TxBuf[3]=0x7c;
                        SPI2TxBuf[4]=0xfe;                       //0xfe;
                        SPI2TxBuf[5]=0x01;
                        STSpiSendCmd(SPI2TxBuf,SPI2RxBuf,10);
                                                                printf("CMD52 Write  Reg addr 0x3f \n"); 
                                                                
                        SPI2TxBuf[0]=0x74;
                        SPI2TxBuf[1]=0x90;              
                        SPI2TxBuf[2]=0x00;               
                        SPI2TxBuf[3]=0x7e;
                        SPI2TxBuf[4]=0x00;                       //0x00;
                        SPI2TxBuf[5]=0x01;
                        STSpiSendCmd(SPI2TxBuf,SPI2RxBuf,10);
                                                                printf("CMD52 Write  Reg addr 0x40 \n"); 
                                                               
                        SPI2TxBuf[0]=0x74;
                        SPI2TxBuf[1]=0x90;              
                        SPI2TxBuf[2]=0x00;               
                        SPI2TxBuf[3]=0x80;
                        SPI2TxBuf[4]=0xd1;                      //0xd1;
                        SPI2TxBuf[5]=0x01;
                        STSpiSendCmd(SPI2TxBuf,SPI2RxBuf,10);
                                                                printf("CMD52 Write  Reg addr 0x29 \n"); 
                                                               
                        SPI2TxBuf[0]=0x74;
                        SPI2TxBuf[1]=0x90;              
                        SPI2TxBuf[2]=0x00;               
                        SPI2TxBuf[3]=0x52;
                        SPI2TxBuf[4]=0x30;                      //0x30;
                        SPI2TxBuf[5]=0x01;
                        STSpiSendCmd(SPI2TxBuf,SPI2RxBuf,10);    
#endif                    
                }
                else
                        break;
                  vTaskDelay(100);
                   spi_proto_ini_status++;   
        } while (1);

}


//void vEXTI7IntHandler(void)
void EXTI9_5_IRQHandler(void)
{
	signed portBASE_TYPE pxHigherPriorityTaskWoken = pdFALSE;
    //printf("SPI ISR ernter in 1 \n");
	if(EXTI_GetITStatus(EXTI_Line7) != RESET)
        {

         //printf("SPI ISR enter in 2 \n");
          if(!ST_Spi2_Int_Status())    //PC4 ½ش0
          {
            //SpiIrqEnable(0);  //ж
            //xSemaphoreGiveFromISR(BusIrqReadSem, pdFALSE);  //û־?
            xSemaphoreGiveFromISR(BusIrqReadSem, &pxHigherPriorityTaskWoken);  //û־?
         //   printf("II\n");  		    
          }
          EXTI_ClearITPendingBit(EXTI_Line7);   //жϱ־λȥ
          
          if(pxHigherPriorityTaskWoken == pdTRUE) {
            portEND_SWITCHING_ISR(pxHigherPriorityTaskWoken);
          }
        }
}
#endif

