/*
* NOTE: жģʽĴ䣬rtosUART1ʼ룬ֻ
* жϴ
*/


#include <stdio.h>
#include <string.h>
#include "FreeRTOS.h"
#include "task.h"
#include "queue.h"
#include "semphr.h"
#include "timers.h"

#include "usart_cfg.h"
#include "stm32f10x.h"
#include "uart_debug.h"

#include "sys/egl_sys_arch.h"

/* Misc defines. */
#define serINVALID_QUEUE				( ( xQueueHandle ) 0 )
#define serNO_BLOCK						( ( portTickType ) 0 )
#define serTX_BLOCK_TIME				( 40 / portTICK_RATE_MS )

/* The queue used to hold received characters. */
static xQueueHandle xRxedChars;
static xQueueHandle xCharsForTx;
static xSemaphoreHandle xRxData;
static int PrasePara(signed char *para_content);

extern u8 tx_buff[];
extern int tx_len ;
//#define UART_DMA_METHOD  

#ifdef UART_DMA_METHOD       
static void Init_UsarDMA(void );
#endif

void Init_UsartQueue(void )
{
        /* Create the queues used to hold Rx/Tx characters. */
	xRxedChars = xQueueCreate( 200, ( unsigned portBASE_TYPE ) sizeof( signed portCHAR ) );
	xCharsForTx = xQueueCreate( 200, ( unsigned portBASE_TYPE ) sizeof( signed portCHAR ) );
	vSemaphoreCreateBinary(xRxData);
	xSemaphoreTake(xRxData,0);
}

//ʹܴIOʱ
//IO
//ʹܴʱ
//ô

//UART2   PA2, TX           PA3  RX 
				   
void Init_Usart(void)
{  /*ڳʼ*/
	
        GPIO_InitTypeDef GPIO_InitStruct;
        USART_InitTypeDef USART_InitStruct;
        NVIC_InitTypeDef NVIC_InitStruct;

        RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA |RCC_APB2Periph_AFIO|  RCC_APB2Periph_USART1,ENABLE);
        //ڵIOʼ
        GPIO_InitStruct.GPIO_Pin = GPIO_Pin_9;
        GPIO_InitStruct.GPIO_Speed = GPIO_Speed_50MHz;
        GPIO_InitStruct.GPIO_Mode = GPIO_Mode_AF_PP;	
        GPIO_Init(GPIOA,&GPIO_InitStruct); //TX	

        GPIO_InitStruct.GPIO_Pin = GPIO_Pin_10;
        GPIO_InitStruct.GPIO_Mode = GPIO_Mode_IN_FLOATING;	
        GPIO_Init(GPIOA,&GPIO_InitStruct); //RX	

        //ڳʼ
        USART_InitStruct.USART_BaudRate  = 921600;//115200;  //9600; //230400;
        USART_InitStruct.USART_WordLength  = USART_WordLength_8b;
        USART_InitStruct.USART_StopBits  = USART_StopBits_1;
        USART_InitStruct.USART_Parity  = USART_Parity_No;  //USART_Parity_Odd;    
        USART_InitStruct.USART_Mode  = USART_Mode_Rx|USART_Mode_Tx;
        USART_InitStruct.USART_HardwareFlowControl  = USART_HardwareFlowControl_None;
        USART_Init(USART1,&USART_InitStruct);

        USART_ClockInitTypeDef USART_ClockInitStructure;
        USART_ClockInitStructure.USART_Clock = USART_Clock_Disable;
        USART_ClockInitStructure.USART_CPOL = USART_CPOL_Low;
        USART_ClockInitStructure.USART_CPHA = USART_CPHA_2Edge;
        USART_ClockInitStructure.USART_LastBit = USART_LastBit_Disable;		
        USART_ClockInit( USART1, &USART_ClockInitStructure );

//ʹܽж
	USART_ITConfig(USART1,USART_IT_RXNE,ENABLE);

	NVIC_InitStruct.NVIC_IRQChannel = USART1_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelPreemptionPriority =  15;      //  1;
	NVIC_InitStruct.NVIC_IRQChannelSubPriority = 0;    // 2;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStruct);
        
	USART_Cmd(USART1,ENABLE);
       Init_UsartQueue();
       
#ifdef UART_DMA_METHOD       
      // Init_UsarDMA();
#endif
}

//USARTַ,queueģʽ
void Usart_SendChar(USART_TypeDef* USARTx,char dat)
{
	while(!USART_GetFlagStatus(USARTx,USART_FLAG_TXE));	
	USART_SendData(USARTx,dat);

}
//USARTݷqueueģʽ
char Usart_GetCahr(USART_TypeDef* USARTx)
{
	char dat;
	while(!USART_GetFlagStatus(USARTx,USART_FLAG_RXNE));
	dat = (char)(USART_ReceiveData(USARTx)&0xff);
	return dat;		
}


//ж

void USART1_IRQHandler(void)
{
        portBASE_TYPE xHigherPriorityTaskWoken = pdFALSE;
        portCHAR cChar;
        if( USART_GetITStatus( USART1, USART_IT_TXE ) == SET )
        {
                //Usart_SendChar(USART1,USART_ReceiveData(USART1)+1);	
                if( xQueueReceiveFromISR( xCharsForTx, &cChar, &xHigherPriorityTaskWoken ) == pdTRUE )
                {
                        USART_ClearFlag(USART1, USART_FLAG_TC);
                        USART_SendData( USART1, cChar );
                        while (USART_GetFlagStatus(USART1, USART_FLAG_TC) == RESET);
                }
                else
                {
                        USART_ITConfig( USART1, USART_IT_TXE, DISABLE );		
                }
        }

        if ( USART_GetITStatus( USART1, USART_IT_RXNE ) == SET )
        {
				
				if (tx_len < 1024*10) {
					tx_buff[tx_len++]  = USART_ReceiveData( USART1 );
					while ( USART_GetITStatus( USART1, USART_IT_RXNE ) == SET ) {
						tx_buff[tx_len++]  = USART_ReceiveData( USART1 );
					}
				}
				xSemaphoreGiveFromISR(xRxData, &xHigherPriorityTaskWoken);  //û־?
				portEND_SWITCHING_ISR( xHigherPriorityTaskWoken );
        }
}


//USARTqueueģʽ
signed portBASE_TYPE xSerialGetChar( signed portCHAR *pcRxedChar, portTickType xBlockTime )
{
	/* Get the next character from the buffer.  Return false if no characters
	are available, or arrive before xBlockTime expires. */
	if( xQueueReceive( xRxedChars, pcRxedChar, xBlockTime ) )
	{
		return pdTRUE;
	}
	else
	{
		return pdFALSE;
	}
}


//USARTqueueģʽ
signed portBASE_TYPE xSerialPutChar( signed portCHAR cOutChar, portTickType xBlockTime )
{
        signed portBASE_TYPE xReturn;
        
#ifdef UART_DMA_METHOD       
                USART_ClearFlag(USART1, USART_FLAG_TC);
                while (USART_GetFlagStatus(USART1, USART_FLAG_TXE) == RESET);
                USART_SendData( USART1, cOutChar );
                while (USART_GetFlagStatus(USART1, USART_FLAG_TC) == RESET);
               xReturn = pdPASS;
#else 

	if( xQueueSend( xCharsForTx, &cOutChar, xBlockTime ) == pdPASS )
	{
                xReturn = pdPASS;
                USART_ITConfig( USART1, USART_IT_TXE, ENABLE );
	}
	else
	{
		xReturn = pdFAIL;
	}
    
#endif    

	return xReturn;
}

void vSerialPutString( const signed portCHAR * const pcString, unsigned portSHORT usStringLength )
{
        signed portCHAR *pxNext;

	/* A couple of parameters that this port does not use. */
	( void ) usStringLength;

	/* Send each character in the string, one at a time. */
	pxNext = ( signed portCHAR * ) pcString;
	while( *pxNext )
	{
		xSerialPutChar( *pxNext, serNO_BLOCK );
		pxNext++;
	}
}


/**********QueueģʽUART TX  ߳***ûõ***************/
// xTaskCreate( vComTxTask, ( signed char * ) "COMTx", configMINIMAL_STACK_SIZE, NULL, tskIDLE_PRIORITY + 1,  NULL );

void vComTxTask( void *pvParameters )
{
        signed char cByteToSend;
        //signed char cByteToSend[30]="vCheckTask created\n\r";
        portTickType xTimeToWait;
        ( void ) pvParameters;
        
        for( ;; )
        {
                /* Simply transmit a sequence of characters from comFIRST_BYTE to
                comLAST_BYTE. */
                for( cByteToSend = comFIRST_BYTE; cByteToSend <= comLAST_BYTE; cByteToSend++ )
                {
                        if( xSerialPutChar( cByteToSend, comNO_BLOCK ) == pdPASS )
                        {
                             ;
                        }
                }
                xTimeToWait = xTaskGetTickCount() + comOFFSET_TIME;

                /* Make sure we don't wait too long... */
                xTimeToWait %= comTX_MAX_BLOCK_TIME;

                /* ...but we do want to wait. */
                if( xTimeToWait < comTX_MIN_BLOCK_TIME )
                {
                        xTimeToWait = comTX_MIN_BLOCK_TIME;
                }
                vTaskDelay( xTimeToWait );
        }
}


/**********QueueģʽUART  RX߳****************/

//xTaskCreate( vComRxTask, ( signed char * ) "COMRx", configMINIMAL_STACK_SIZE, NULL, tskIDLE_PRIORITY + 1, NULL );

void uartRxTask( void *pvParameters )
{
	u32 delay_ticks = portMAX_DELAY;
	extern egl_sem_t BusIrqReadSem;
	for( ;; ) {
		if (xSemaphoreTake(xRxData,delay_ticks) == pdTRUE) {
			delay_ticks = 20;
		} else {
			delay_ticks = portMAX_DELAY;
			if ((tx_len == strlen("+testsend\r\n")) && (memcmp("+testsend\r\n",tx_buff,tx_len) == 0)) {
				tx_len = 8*1024;
				memset(tx_buff,'Q',tx_len);
			} else {
                            printf("STM32 recv %d bytes\r\n",tx_len);
                        }
			xSemaphoreGive(BusIrqReadSem);  //û־?
		}
	}
}

void vComRxTask( void *pvParameters )
{
        signed char cExpectedByte, cByteRxed;
        portBASE_TYPE xResyncRequired = pdFALSE;
	( void ) pvParameters;
        printf("com rx task \n");

	for( ;; )
	{                                        
		for( cExpectedByte = comFIRST_BYTE; cExpectedByte <=comLAST_BYTE ; cExpectedByte++ )
		{
			/* Block on the queue that contains received bytes until a byte is
			available. */
			if( xSerialGetChar( &cByteRxed, comRX_BLOCK_TIME ) )
			{

				if( cByteRxed == cExpectedByte )
				{
					;
				}
				else
				{
					xResyncRequired = pdTRUE;
					break; /*lint !e960 Non-switch break allowed. */
				}
			}
		  }

		if( xResyncRequired == pdTRUE )
		{
			while( cByteRxed != comLAST_BYTE )
			{
				/* Block until the next char is available. */
				xSerialGetChar( &cByteRxed, comRX_BLOCK_TIME );
			}
			/* We have now resynced with the Tx task and can continue. */
			xResyncRequired = pdFALSE;
		}
		else
		{
		        printf("SEND SUCC\n");
		}
              vTaskDelay(50);
	}
}


/**********QueueģʽUART  RX ߳**************/
//xTaskCreate( vComRxCmdPraseTask, ( signed char * ) "CMDPrase", configMINIMAL_STACK_SIZE, NULL, tskIDLE_PRIORITY + 1, NULL );

//uart cmd prase thread, for debug usage
void vComRxCmdPraseTask( void *pvParameters )
{
        signed char cByteRxed[20];
        char rx_i = 0;
        unsigned char cmd_i=0;
        portBASE_TYPE xCmdFound = pdFALSE;

    
	( void ) pvParameters;
        printf("com rx cmd prase task \n");

	for( ;; )
	{                                        
		/* Block on the queue that contains received bytes until a byte is available. */
		if( xSerialGetChar( cByteRxed+rx_i, comRX_BLOCK_TIME ) )
		{
		//printf("%d",cByteRxed[rx_i]);
			if( cByteRxed[rx_i] == 13 )
			{
			       cByteRxed[rx_i] = '\0'; 
                            xCmdFound = pdFALSE;

                           /* 
                            for(char t =0; t<15; t++)
                            {
                                  printf("%x ",UartDbgCmd[0][t]);
                            }
                            printf("\n");
                            for(char t =0; t<15; t++)
                                  printf("%x ",cByteRxed[t]);
                            printf("comp:%d\n",strcmp(UartDbgCmd[0],cByteRxed) );
                            */
                            
                            printf("%s\n",cByteRxed);
                           
                            for( cmd_i = 0; strcmp(UartDbgCmd[cmd_i],"end") != 0; cmd_i++ )
                            {
                                    if( strcmp(UartDbgCmd[cmd_i],cByteRxed) == 0 )
                                    {
                                            xCmdFound = pdTRUE;
                                            break;
                                    }
                             } 
                            
                		if( xCmdFound == pdTRUE )
                		{
                                      UartDbgCmdHandle(cmd_i,0);
                                      
                		}
                		else
                		{
                		        printf("no this cmd\n");
                		}
                            rx_i = 0;
                     }
                    else
                    {
                             rx_i++;
                             if(rx_i >= 20)
                                    rx_i = 0;
                    }
		}
              vTaskDelay(100);
	}
}

        /**********UART  RX ʱ**************/
void vComRxCmdPraseTimHdl( xTimerHandle pxTimer )
{
        static signed char cByteRxed[40];
        static char rx_i = 0;
        
             //prase cmd to two parts, one is cmd, other is para.
        unsigned char cmd_i=0;
        portBASE_TYPE xCmdFound = pdFALSE;
        int num,i;     
	/* Block on the queue that contains received bytes until a byte is available. */
	if( xSerialGetChar( cByteRxed+rx_i, comRX_BLOCK_TIME ) )
	{
	//printf("%d",cByteRxed[rx_i]);
		if( cByteRxed[rx_i] == 13 )
		{
		////debug_diff
                    cByteRxed[rx_i] = '\0'; 
                    xCmdFound = pdFALSE;

                    /* 
                    for(char t =0; t<15; t++)
                    {
                          printf("%x ",UartDbgCmd[0][t]);
                    }
                    printf("\n");
                    for(char t =0; t<15; t++)
                          printf("%x ",cByteRxed[t]);
                    printf("comp:%d\n",strcmp(UartDbgCmd[0],cByteRxed) );
                    */
                    
                    //printf("%s\n",cByteRxed);
                    
                    num = 0;
                    //prase cmd into two parts
                    for(i=0; i<rx_i; i++) 
                    {
                            if(cByteRxed[i]=='-')
                            {
                                    //memcpy( para_content , cByteRxed + i , rx_i - i );
                                    num = PrasePara(cByteRxed + i);
                                            //printf("num2:%d\n",num);
                                    cByteRxed[i-1]=0;   
                                    break;
                            }
                    }

                    for( cmd_i = 0; strcmp(UartDbgCmd[cmd_i],"end") != 0; cmd_i++ )
                    {
                            if( strcmp(UartDbgCmd[cmd_i],cByteRxed) == 0 )
                            {
                                    xCmdFound = pdTRUE;
                                    break;
                            }
                     } 
                        
            		if( xCmdFound == pdTRUE )
            		{
                                 UartDbgCmdHandle(cmd_i,num);
            		}
            		else
            		{
            		        printf("no this cmd\n");
            		}
                        rx_i = 0;
                 }
                else
                {
                         rx_i++;
                         if(rx_i >= 40)
                                rx_i = 0;
                }
	}
}
        
static int PrasePara(signed char *para_content)
{
        char i;
        int num = 0;
        i = 0;
        //printf("%s\n",para_content);
        
        while( *(para_content+i)!=0 )       //poll until 'enter' key
        {
                if( *(para_content+i) = '-' )       //here come the para.
                {
                        //printf("a: %d\n",*(para_content+i));
                        i++;
                        switch( *(para_content+i) )
                        {
                                case 'n':       //num
                                    //printf("b: %d\n",*(para_content+i));
                                    i += 2;
                                    //printf("c: %d\n",*(para_content+i) );
                                    while( *(para_content+i)!=' ' && *(para_content+i)!=0 )
                                    {
                                            //printf("d: %d\n",*(para_content+i) );
                                            if( *(para_content+i) < 48 || *(para_content+i) > 57 )
                                                    *(para_content+i) = 48;    
                                            num = num*10 + *(para_content+i)-48;
                                            i++;
                                    }
                                    break;
                                default:
                                    break;
                        }
                }
                
                if(*(para_content+i)!=0)
                        i++;
        }
        return num;
}




/**********DMAģʽUART ******************/
/*
void Init_UsarDMA(void )
{
        DMA_InitTypeDef DMA_InitStruct;
        RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1,ENABLE);
        USART_DMACmd(USART1,USART_DMAReq_Tx,ENABLE);
	char buf[]="hello world \r\n";
        //DMA
        DMA_InitStruct.DMA_PeripheralBaseAddr = (u32)(&USART1->DR);
        DMA_InitStruct.DMA_MemoryBaseAddr = (u32)buf;
        DMA_InitStruct.DMA_DIR = DMA_DIR_PeripheralDST;
        DMA_InitStruct.DMA_BufferSize = sizeof(buf)-1;
        DMA_InitStruct.DMA_PeripheralInc = DMA_PeripheralInc_Disable;
        DMA_InitStruct.DMA_MemoryInc = DMA_MemoryInc_Enable;
        DMA_InitStruct.DMA_PeripheralDataSize = DMA_PeripheralDataSize_HalfWord;
        DMA_InitStruct.DMA_MemoryDataSize = DMA_PeripheralDataSize_Byte;
        DMA_InitStruct.DMA_Mode = DMA_Mode_Normal;
        DMA_InitStruct.DMA_Priority = DMA_Priority_High;
        DMA_InitStruct.DMA_M2M = DMA_M2M_Disable;
        DMA_Init(DMA1_Channel4,&DMA_InitStruct);
        DMA_Cmd(DMA1_Channel4,ENABLE);

}
*/
