#ifndef __usart_poll
#define __usart_poll

#include "FreeRTOS.h"
#include "queue.h"
#include "semphr.h"
#include "timers.h"

#include "stm32f10x.h"


//Ķ嶼ڲԵġ
#define comTOTAL_PERMISSIBLE_ERRORS ( 2 )

/* The Tx task will transmit the sequence of characters at a pseudo random
interval.  This is the maximum and minimum block time between sends. */
#define comTX_MAX_BLOCK_TIME		( ( portTickType ) 0x96 )
#define comTX_MIN_BLOCK_TIME		( ( portTickType ) 0x32 )
#define comOFFSET_TIME				( ( portTickType ) 3 )

/* We should find that each character can be queued for Tx immediately and we
don't have to block to send. */
#define comNO_BLOCK					( ( portTickType ) 0 )

/* The Rx task will block on the Rx queue for a long period. */
#define comRX_BLOCK_TIME			( ( portTickType ) 0xffff )

/* The sequence transmitted is from comFIRST_BYTE to and including comLAST_BYTE. */
#define comFIRST_BYTE				( 'A' )
#define comLAST_BYTE				( 'C' )

#define comBUFFER_LEN				( ( unsigned portBASE_TYPE ) ( comLAST_BYTE - comFIRST_BYTE ) + ( unsigned portBASE_TYPE ) 1 )
#define comINITIAL_RX_COUNT_VALUE	( 0 )


//
void Init_Usart(void);
void Init_UsartQueue(void );

//USARTqueueģʽ
signed portBASE_TYPE xSerialGetChar( signed portCHAR *pcRxedChar, portTickType xBlockTime );
//USARTqueueģʽ
signed portBASE_TYPE xSerialPutChar( signed portCHAR cOutChar, portTickType xBlockTime );

//USARTַ
void Usart_SendChar(USART_TypeDef* USARTx,char dat);
//USART
char Usart_GetCahr(USART_TypeDef* USARTx);


//߳ 
void vComTxTask( void *pvParameters );
void vComRxTask( void *pvParameters );

//UART ߳ 
void vComRxCmdPraseTask( void *pvParameters );
//UART öʱ
void vComRxCmdPraseTimHdl( xTimerHandle pxTimer );
#endif
